com.jnape.palatable.lambda.functions.specialized

## Interface BiSemigroupFactory<A,B,C>

- All Superinterfaces:
    Applicative<Fn1<B,Fn1<C,Fn1<C,C>>>,Fn1<A,?>>, Cartesian<A,Fn1<B,Fn1<C,Fn1<C,C>>>,Fn1<?,?>>, Cocartesian<A,Fn1<B,Fn1<C,Fn1<C,C>>>,Fn1<?,?>>, Contravariant<A,Profunctor<?,Fn1<B,Fn1<C,Fn1<C,C>>>,Fn1<?,?>>>, Fn1<A,Fn1<B,Fn1<C,Fn1<C,C>>>>, Fn2<A,B,Fn1<C,Fn1<C,C>>>, Fn3<A,B,C,Fn1<C,C>>, Fn4<A,B,C,C,C>, Functor<Fn1<B,Fn1<C,Fn1<C,C>>>,Fn1<A,?>>, Monad<Fn1<B,Fn1<C,Fn1<C,C>>>,Fn1<A,?>>, MonadReader<A,Fn1<B,Fn1<C,Fn1<C,C>>>,Fn1<A,?>>, MonadRec<Fn1<B,Fn1<C,Fn1<C,C>>>,Fn1<A,?>>, MonadWriter<A,Fn1<B,Fn1<C,Fn1<C,C>>>,Fn1<A,?>>, Profunctor<A,Fn1<B,Fn1<C,Fn1<C,C>>>,Fn1<?,?>>
  All Known Subinterfaces:
    BiMonoidFactory<A,B,C>
  All Known Implementing Classes:
    Collapse, Collapse, Merge, Merge, MergeMaps
  Functional Interface:
    This is a functional interface and can therefore be used as the assignment target for a lambda expression or method reference.

      @FunctionalInterface
      public interface BiSemigroupFactory<A,B,C>
      extends Fn4<A,B,C,C,C>

- - ### Method Summary

    All Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method and Description
    --- | ---
    `default SemigroupFactory<B,C>` | `apply(A a)` Partially apply this function by taking its first argument.
    `default Semigroup<C>` | `apply(A a, B b)` Partially apply this function by taking its first two arguments.
    `Semigroup<C>` | `checkedApply(A a, B b)`
    `default C` | `checkedApply(A a, B b, C c, C d)`
    `default BiSemigroupFactory<B,A,C>` | `flip()` Flip the order of the first two arguments.
    `default SemigroupFactory<? super Product2<? extends A,? extends B>,C>` | `uncurry()` Returns an `Fn3` that takes the first two arguments as a ``Product2`<A, B>` and the third and fourth arguments.

    - ### Methods inherited from interface com.jnape.palatable.lambda.functions.Fn4

      `apply, apply, checkedApply, compose, contraMap, diMapL, discardR, fn4, fn4, fn4, fn4, widen`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functions.Fn3

      `fn3, fn3, fn3`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functions.Fn2

      `checkedApply, curried, curry, fn2, fromBiFunction, toBiFunction`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functions.Fn1

      `andThen, carry, cartesian, censor, choose, cocartesian, diMap, diMapR, discardL, flatMap, fmap, fn1, fromFunction, lazyZip, listens, local, pure, pureFn1, thunk, toFunction, trampolineM, zip, zip`

    - ### Methods inherited from interface com.jnape.palatable.lambda.monad.Monad

      `join`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functor.Functor

      `coerce`

- - ### Method Detail

    - #### checkedApply

          Semigroup<C> checkedApply(A a,
                                    B b)
                             throws Throwable

      Description copied from interface: `Fn3`
      Specified by:
        `checkedApply` in interface `Fn2<A,B,Fn1<C,Fn1<C,C>>>`
      Specified by:
        `checkedApply` in interface `Fn3<A,B,C,Fn1<C,C>>`
      Throws:
        `Throwable`

    - #### checkedApply

          default C checkedApply(A a,
                                 B b,
                                 C c,
                                 C d)
                          throws Throwable

      Specified by:
        `checkedApply` in interface `Fn4<A,B,C,C,C>`
      Throws:
        `Throwable`

    - #### apply

          default Semigroup<C> apply(A a,
                                     B b)

      Description copied from interface: `Fn4`
      Partially apply this function by taking its first two arguments.
      Specified by:
        `apply` in interface `Fn2<A,B,Fn1<C,Fn1<C,C>>>`
      Specified by:
        `apply` in interface `Fn3<A,B,C,Fn1<C,C>>`
      Specified by:
        `apply` in interface `Fn4<A,B,C,C,C>`
      Parameters:
        `a` - the first argument
        `b` - the second argument
      Returns:
        an `Fn2`<C, D, E>

    - #### apply

          default SemigroupFactory<B,C> apply(A a)

      Description copied from interface: `Fn4`
      Partially apply this function by taking its first argument.
      Specified by:
        `apply` in interface `Fn1<A,Fn1<B,Fn1<C,Fn1<C,C>>>>`
      Specified by:
        `apply` in interface `Fn2<A,B,Fn1<C,Fn1<C,C>>>`
      Specified by:
        `apply` in interface `Fn3<A,B,C,Fn1<C,C>>`
      Specified by:
        `apply` in interface `Fn4<A,B,C,C,C>`
      Parameters:
        `a` - the first argument
      Returns:
        an `Fn3`<B, C, D, E>

    - #### flip

          default BiSemigroupFactory<B,A,C> flip()

      Description copied from interface: `Fn4`
      Flip the order of the first two arguments.
      Specified by:
        `flip` in interface `Fn2<A,B,Fn1<C,Fn1<C,C>>>`
      Specified by:
        `flip` in interface `Fn3<A,B,C,Fn1<C,C>>`
      Specified by:
        `flip` in interface `Fn4<A,B,C,C,C>`
      Returns:
        an `Fn4`<B, A, C, D, E>

    - #### uncurry

          default SemigroupFactory<? super Product2<? extends A,? extends B>,C> uncurry()

      Description copied from interface: `Fn4`
      Returns an `Fn3` that takes the first two arguments as a ``Product2`<A, B>` and the third and fourth arguments.
      Specified by:
        `uncurry` in interface `Fn2<A,B,Fn1<C,Fn1<C,C>>>`
      Specified by:
        `uncurry` in interface `Fn3<A,B,C,Fn1<C,C>>`
      Specified by:
        `uncurry` in interface `Fn4<A,B,C,C,C>`
      Returns:
        an `Fn3` taking a `Product2` and the third and fourth arguments